#pragma once
#ifndef PRODUKT_FILTER_H
#define PRODUKT_FILTER_H

#include "session.h"

#include <cassert>
#include <string>

class Gebot_impl;

namespace Auktion {

    class ProduktFilter_impl: virtual public ProduktFilter_Session
    {
        public:
            ProduktFilter_impl(const char* name);
            virtual ~ProduktFilter_impl(void);

            //  comes from CCM_ProduktFilter
            virtual char* interessanter_gegenstand();
            virtual void  interessanter_gegenstand(const char* value);

            virtual void push_eingehende_gebote(Gebot* conxn);


            //  comes from Components::SessionComponent
            virtual void set_session_context(Components::SessionContext_ptr ctx);

            virtual void ccm_activate()  {};
            virtual void ccm_passivate() {};
            virtual void ccm_remove()    {};

        private:
            CCM_ProduktFilter_Context_var context_;     //  container context

            std::string name_;                          //  interested subject
    };

}

#endif  //  PRODUKT_FILTER_H
